<?php


namespace App\Controller;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

use App\Entity\Librairie;


class LibrairieController extends  AbstractController
{
    /**
     * @Route("/listLibraries",name="show_library")
     */
    public function listLibraries(Request $request)
    {

        $librairies = $this->getDoctrine()
            ->getRepository(Librairie::class)
            ->findAll();


        return $this->render('librairie/main.html.twig', array('librairies' => $librairies));

    }



    /**
     * @Route("/addLibrary", name="add_library")
     */
    public function addLibrary(Request $request){
        $nom=$request->request->get('nom');
        $type=$request->request->get('type');
        $fabricant=$request->request->get('fabricant');
        $nbslots=$request->request->get('nbslots');

        $em = $this->getDoctrine()->getManager();

        /** @var TYPE_NAME $exception */
        try {

            $entityManager = $this->getDoctrine()->getManager();

            $librairy=new Librairie();
            $librairy->setNom($nom);
            $librairy->setType($type);
            $librairy->setFabricant($fabricant);
            $librairy->setNbslots($nbslots);
            $librairy->setDatecreation(new \DateTime());
            $entityManager->persist($librairy);
            $entityManager->flush();

            $response = new Response(json_encode(array(
                'status' => '200',
                'message' => 'Base de données mise à jour'
            )));

        }
        catch (DBALException $e) {

            $response = new Response(json_encode(array(
                'status' => '500',
                'message' => $e
            )));
        }


        $response->headers->set('Content-Type', 'application/json');
        return $response;

    }

    /**
     * @Route("/editLibrary", name="edit_library")
     */
    public function editLibrary(Request $request){

        $id=$request->request->get('id');
        $nom=$request->request->get('nom');
        $type=$request->request->get('type');
        $fabricant=$request->request->get('fabricant');
        $nbslots=(int) $request->request->get('nbslots');

        $em = $this->getDoctrine()->getManager();

        /** @var TYPE_NAME $exception */
        try {

            $id=$request->request->get('id');
            $em = $this->getDoctrine()->getManager();

            $librairy=$this->getDoctrine()
                    ->getRepository(Librairie::class)->find($id);
            $librairy->setNom($nom);
            $librairy->setType($type);
            $librairy->setFabricant($fabricant);
            $librairy->setNbslots($nbslots);

            $em->persist($librairy);
            $em->flush();

            $response = new Response(json_encode(array(
                'status' => '200',
                'message' => 'Base de données mise à jour'
            )));

        }
        catch (DBALException $e) {

            $response = new Response(json_encode(array(
                'status' => '500',
                'message' => $e
            )));
        }


        $response->headers->set('Content-Type', 'application/json');
        return $response;

    }

    /**
     * @Route("/removeLibrary", name="remove_library")
     */
    public function removeLibrary(Request $request){
        $id=$request->request->get('id');
        $em = $this->getDoctrine()->getManager();

        /** @var TYPE_NAME $exception */
        try {
            $librairy=$this->getDoctrine()
                ->getRepository(Librairie::class)->find($id);

            $em->remove($librairy);
            $em->flush($librairy);


            $response = new Response(json_encode(array(
                'status' => '200',
                'message' => 'Base de données mise à jour'
            )));

        }
        catch (DBALException $e) {

            $response = new Response(json_encode(array(
                'status' => '500',
                'message' => $e
            )));
        }


        $response->headers->set('Content-Type', 'application/json');
        return $response;

    }
}
