<?php


namespace App\Controller;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use App\Entity\TapeModele;

class TapeController extends AbstractController
{
    /**
     * @Route("/listModels",name="show_models")
     */
    public function listModels(Request $request)
    {
       
        $models = $this->getDoctrine()
            ->getRepository(TapeModele::class)
            ->findAll();



        return $this->render('tapes/main.html.twig', array('models' => $models));


    }



    /**
     * @Route("/addModel", name="add_Model")
     */
    public function addModel(Request $request){
        $nom=$request->request->get('nom');        
        $fabricant=$request->request->get('fabricant');
        $capacite=$request->request->get('capacite');
        $longueur=$request->request->get('longueur');
        
        $em = $this->getDoctrine()->getManager();

        /** @var TYPE_NAME $exception */
        try {

            $entityManager = $this->getDoctrine()->getManager();

            $model=new TapeModele();
            $model->setNom($nom);
            $model->setFabricant($fabricant);
            $model->setCapacite($capacite);
            $model->setLongueur($longueur);
            $model->setDatecreation(new \DateTime());
            $entityManager->persist($model);
            $entityManager->flush();

            $response = new Response(json_encode(array(
                'status' => '200',
                'message' => 'Base de données mise à jour'
            )));

        }
        catch (DBALException $e) {

            $response = new Response(json_encode(array(
                'status' => '500',
                'message' => $e
            )));
        }


        $response->headers->set('Content-Type', 'application/json');
        return $response;

    }

    /**
     * @Route("/editModel", name="edit_Model")
     */
    public function editModel(Request $request){

        $id=$request->request->get('id');
        $nom=$request->request->get('nom');
        $fabricant=$request->request->get('fabricant');
        $capacite=$request->request->get('capacite');
        $longueur=$request->request->get('longueur');

        $em = $this->getDoctrine()->getManager();

        /** @var TYPE_NAME $exception */
        try {

            $id=$request->request->get('id');
            $em = $this->getDoctrine()->getManager();

            $model=$this->getDoctrine()
                ->getRepository(TapeModele::class)->find($id);
            $model->setNom($nom);
            $model->setFabricant($fabricant);
            $model->setCapacite($capacite);
            $model->setLongueur($longueur);

            $em->persist($model);
            $em->flush();

            $response = new Response(json_encode(array(
                'status' => '200',
                'message' => 'Base de données mise à jour'
            )));

        }
        catch (DBALException $e) {

            $response = new Response(json_encode(array(
                'status' => '500',
                'message' => $e
            )));
        }


        $response->headers->set('Content-Type', 'application/json');
        return $response;

    }

    /**
     * @Route("/removeModel", name="remove_Model")
     */
    public function removeModel(Request $request){
        $id=$request->request->get('id');
        $em = $this->getDoctrine()->getManager();

        /** @var TYPE_NAME $exception */
        try {
            $model=$this->getDoctrine()
                ->getRepository(TapeModele::class)->find($id);

            $em->remove($model);
            $em->flush($model);


            $response = new Response(json_encode(array(
                'status' => '200',
                'message' => 'Base de données mise à jour'
            )));

        }
        catch (DBALException $e) {

            $response = new Response(json_encode(array(
                'status' => '500',
                'message' => $e
            )));
        }


        $response->headers->set('Content-Type', 'application/json');
        return $response;

    }

}